//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%38188C7CA420.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%38188C7CA420.cm

//## begin module%38188C7CA420.cp preserve=no
//## end module%38188C7CA420.cp

//## Module: ModelContainer%38188C7CA420; Package specification
//## Subsystem: XSModel::GlobalContainer%3E4293160205
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/GlobalContainer/ModelContainer.h

#ifndef MODELCONTAINER_H
#define MODELCONTAINER_H 1

//## begin module%38188C7CA420.additionalIncludes preserve=no
//## end module%38188C7CA420.additionalIncludes

//## begin module%38188C7CA420.includes preserve=yes
#include <set>
//## end module%38188C7CA420.includes

// ctype
#include <ctype.h>
// Error
#include <XSUtil/Error/Error.h>
// cstdlib
#include <cstdlib>
// Observer
#include <XSUtil/Utils/Observer.h>
// ModelTypes
#include <XSModel/GlobalContainer/ModelTypes.h>
// Cosmology
#include <XSModel/GlobalContainer/Cosmology.h>
// Model
#include <XSModel/Model/Model.h>

class DataSet;
class Response;
//## Modelname: XSModel::GlobalContainer%3E42929A0210
namespace XSContainer {
    class MdefContainer;
} // namespace XSContainer

class Component;
class MixBase;
class Parameter;

//## begin module%38188C7CA420.declarations preserve=no
//## end module%38188C7CA420.declarations

//## begin module%38188C7CA420.additionalDeclarations preserve=yes
//## end module%38188C7CA420.additionalDeclarations


namespace XSContainer {
    //## begin XSContainer%3E42929A0210.initialDeclarations preserve=yes
    //## end XSContainer%3E42929A0210.initialDeclarations

    //## begin XSContainer::ModelContainer%368930276EF8.preface preserve=yes
    //## end XSContainer::ModelContainer%368930276EF8.preface

    //## Class: ModelContainer%368930276EF8
    //	Container for the model structures. Singleton.
    //## Category: XSModel::GlobalContainer%3E42929A0210
    //## Subsystem: XSModel::GlobalContainer%3E4293160205
    //## Persistence: Transient
    //## Cardinality/Multiplicity: 1..1



    //## Uses: <unnamed>%381616EAEE48;Subject { -> }
    //## Uses: <unnamed>%3ABA71B60021;Response { -> F}
    //## Uses: <unnamed>%3ABA71BC02E2;ResponseContainer { -> }
    //## Uses: <unnamed>%3E42963703DC;DataContainer { -> }
    //## Uses: <unnamed>%3ED640DD0282;DataSet { -> F}
    //## Uses: <unnamed>%3EFB1FD900D0;Component { -> F}

    class ModelContainer : public Observer, //## Inherits: <unnamed>%381605D3B7B8
                           	public Subject  //## Inherits: <unnamed>%3C72CD9E03DB
    {
      //## begin XSContainer::ModelContainer%368930276EF8.initialDeclarations preserve=yes
      //## end XSContainer::ModelContainer%368930276EF8.initialDeclarations

      public:
        //## Class: NoSuchParameter%3C0BB1840355
        //## Category: XSModel::GlobalContainer%3E42929A0210
        //## Subsystem: XSModel::GlobalContainer%3E4293160205
        //## Persistence: Transient
        //## Cardinality/Multiplicity: n



        class NoSuchParameter : public YellowAlert  //## Inherits: <unnamed>%3C0BB229031B
        {
          public:
            //## Constructors (specified)
              //## Operation: NoSuchParameter%3C0BB19901E2
              NoSuchParameter (int index, const string& modelName);

          protected:
          private:
          private: //## implementation
        };

        //## Destructor (generated)
          ~ModelContainer();


        //## Other Operations (specified)
          //## Operation: Instance%373B0D27BC74;      C++
          static ModelContainer* Instance ();

          //## Operation: Update%38188F27FE20
          virtual void Update (Subject* data = 0);

          //## Operation: addToList%3A8D7725028B
          void addToList (Model* newModel);

          //## Operation: addParameterToList%3A9C16200022
          void addParameterToList (const string& key, Parameter* value);

          //## Operation: deregisterModelParameters%3A9C16290225
          //	Erase parameters from the global parameter list.
          //
          //	Calls reindex to move index values of parameters
          //	with higher index numbers.
          void deregisterModelParameters (const string& keyString);

          //## Operation: lookupParameter%3A9C163503E0
          Parameter* lookupParameter (int index, const string& model = string()) const;

          //## Operation: lookupParameter%3A9C163B026C
          Parameter* lookupParameter (const string& qualKey) const;

          //## Operation: remove%3A9D17FA01EF
          //	Internal engine for removing a model from the container
          //	and its parts from the global lists.
          void remove (const string& name);

          //## Operation: remove%3A9D184000FB
          //	remove individual model group instance.
          void remove (const string& name, size_t group);

          //## Operation: lookup%3A9E6A2C0351
          //	returns pointer to Model identified by name and data
          //	group number.
          Model* lookup (const string& name, size_t group = 0);

          //## Operation: clearLists%3AA5440002CE
          void clearLists ();

          //## Operation: isModel%3AB8DC240078
          //	Simple function that returns true if a model by name
          //	of the argument has been defined.
          bool isModel (const string& name);

          //## Operation: attachResponses%3ABA4B9C0320
          //## Exceptions: YellowAlert&
          void attachResponses (const string& modelName) throw (YellowAlert&);

          //## Operation: calculate%3AC4B9090120
          void calculate (const string& modelName, bool saveComponentFlux = false, bool frozen = false) const;

          //## Operation: setParameterFromPrompt%3C0BA8CE011F
          void setParameterFromPrompt (int index, const string& modelName = string(), const string& inputArg = string()) const;

          //## Operation: indexToName%3C0BC5E402F8
          string indexToName (int index, const string& modelName) const;

          //## Operation: setCompute%3C20EDE000EB
          //	global driver for manipulating Component's recompute
          //	flag.
          void setCompute (const string& name, bool value = true);

          //## Operation: keyToIndex%3C223AC903C7
          int keyToIndex (const string& key) const;

          //## Operation: setFirstOfModelName%3C83DF250142
          void setFirstOfModelName (Model* newModel);

          //## Operation: modelName%3C8D09330120
          //	return model name corresponding to unique index number.
          //	Most expedient to search through the model map and grab
          //	an index from the first model that matches the name.
          string modelName (int index) const;

          //## Operation: countRate%3CF3E7AD02DA
          Real countRate (size_t spectrumNumber) const;

          //## Operation: fullIndex%3D3EB3D3012B
          //	utility function that assists the conversion of a model
          //	name qualified parameter index number from user input of
          //	the form
          //
          //	modelName:n
          int fullIndex (int index, const string& modelName) const;

          //## Operation: makeSourceComponents%3DF642C10135
          void makeSourceComponents ();

          //## Operation: foldSources%3DF8D0F00071
          void foldSources ();

          //## Operation: clearSources%3DFE185E0195
          //## Exceptions: ()
          void clearSources () throw ();

          //## Operation: fold%3ED5279D0174
          void fold ();

          //## Operation: lookupModelGroup%3EF89C35019D
          std::vector<Model*> lookupModelGroup (const string& modelName = string()) const;

          //## Operation: fillFakeData%3ED63F9E0172
          void fillFakeData (DataSet* dSet) const;

          //## Operation: explActiveSources%3ED678A502DD
          void explActiveSources (IntegerArray& sourceNums) const;

          //## Operation: eraseComponentParameters%3EFB065503C0
          int eraseComponentParameters (Component* doomed);

          //## Operation: registerModel%3EFB2432031A
          void registerModel (Model* model);

          //## Operation: calcEqWidths%3F032F4D0182
          Real calcEqWidths (const EqWidthRecord& currComp, Model* mod);

          //## Operation: deregisterParameter%3F0C5F4D0191
          void deregisterParameter (int oldIndex, int modelIndex);

          //## Operation: registerModelParameters%3F300F6E019B
          //	Erase parameters from the global parameter list.
          //
          //	Calls reindex to move index values of parameters
          //	with higher index numbers.
          void registerModelParameters (const string& keyString);

          //## Operation: saveData%3F301325005C
          void saveData (std::ostream& s);

          //## Operation: restoreFluxes%3F871BA10213
          void restoreFluxes (const string& modelName, const GroupFluxContainer& savedFluxes) const;

          //## Operation: storeFluxes%3F871B780177
          void storeFluxes (const string& modelName, GroupFluxContainer& fluxes) const;

          //## Operation: fold%3F871C85027A
          void fold (const string& modelName) const;

          //## Operation: makeDerivatives%3F9011190120
          void makeDerivatives (const string& modelName, GroupFluxContainer& difference, Real delta, ArrayContainer& foldedDerivative) const;

          //## Operation: resetComponentFluxes%3F90119901B9
          void resetComponentFluxes (const string& modelName) const;

          //## Operation: storeFluxErrors%3F9418E5022F
          void storeFluxErrors (const string& modelName, GroupFluxContainer& fluxErrors) const;

          //## Operation: restoreFluxErrors%3F941900018E
          void restoreFluxErrors (const string& modelName, const GroupFluxContainer& savedFluxes) const;

          //## Operation: gatherGroupEnergy%3F954F9B0145
          EnergyPointer gatherGroupEnergy (const string& modelName) const;

          //## Operation: deactivateModel%3FB3D7D20043
          void deactivateModel (const string& name);

          //## Operation: removeMixingComponent%405B182F0081
          void removeMixingComponent (const string& name);

          //## Operation: SHIFT%41598DE001CA
          static size_t SHIFT ();

          //## Operation: lookup%415AFD09014E
          Model* lookup (const Response* resp);

          //## Operation: applyAutonomousEnergies%44037A170088
          void applyAutonomousEnergies (const RealArray& energyArray);

          //## Operation: modifyExtendedEnergies%44F7129D0312
          void modifyExtendedEnergies (const ExtendRecord& extend, bool isHigh);

          //## Operation: rerouteBrokenParLinks%445F494903B6
          void rerouteBrokenParLinks (std::vector<Model*>& doomedMods);

          //## Operation: lookupModelForSource%447DF09D0199
          string lookupModelForSource (size_t sourceNum) const;

          //## Operation: isExtended%44F710870023
          bool isExtended () const;

          //## Operation: getModsForSpec%45228ED40369
          std::vector<const Model*> getModsForSpec (const SpectralData* spectrum);

          //## Operation: applyExtendedEnergies%4558DF9300D7
          void applyExtendedEnergies ();

          //## Operation: flagDoomedPars%4582F99B01ED
          static void flagDoomedPars (std::vector<Model*>& doomedMods);

          //## Operation: userToInternalParIndex%45DCA98701EF
          std::vector<size_t> userToInternalParIndex (const std::vector<size_t>& userIndices, const string& modName) const;

          //## Operation: internalToUserParIndex%45DCAA100286
          std::vector<size_t> internalToUserParIndex (const std::vector<size_t>& internalIndices, const string& modName) const;

          //## Operation: designateActive%4689745F01ED
          //	Public wrapper function for assigning a Model explicit
          //	active status (though may be either on or off).  This
          //	deactivates any other Model that was active for the
          //	source number, and updates the necessary internal arrays.
          void designateActive (const Model* mod);

          //## Operation: showModel%46EFE679039F
          void showModel () const;

          //## Operation: reportModelRate%46EFEE8303DF
          void reportModelRate (size_t specNum, size_t dgNum, const RealArray& aScale);

        //## Get and Set Operations for Class Attributes (generated)

          //## Attribute: modelSystematicError%3E9C41E50388
          Real modelSystematicError () const;
          void modelSystematicError (Real value);

          //## Attribute: autonomousEnergy%44037A2C03A0
          const RealArray& autonomousEnergy () const;

          //## Attribute: extendedEnergy%44F70F470376
          const ExtendRange& extendedEnergy () const;

          //## Attribute: proportionalDelta%47064F7A01FB
          //	If this is set to a positive finite value, model
          //	parameters will use this to produce a fit delta
          //	proportional to the parameter value.
          Real proportionalDelta () const;
          void proportionalDelta (Real value);

        //## Get and Set Operations for Associations (generated)

          //## Association: XSModel::GlobalContainer::Cosmology Parameters%3E8DF06B0306
          //## Role: ModelContainer::cosmo%3E8DF06C019F
          Cosmology& cosmo ();
          void cosmo (const Cosmology& value);

          //## Association: XSModel::GlobalContainer::<unnamed>%4810808503E5
          //## Role: ModelContainer::userMdefs%48108086039D
          //	Storing this by pointer only to get away with a forward
          //	declaration to MdefContainer.
          MdefContainer* userMdefs ();

          //## Association: XSModel::Model::<unnamed>%36893410E850
          //## Role: ModelContainer::modelSet%368934115728
          const ModelMap& modelSet () const;

          //## Association: XSModel::Model::<unnamed>%3A9C16A801F0
          //## Role: ModelContainer::parameterList%3A9C16A801F2
          //## Qualifier: key%3A9C16A801F3; string
          const std::map<string,Parameter*>& parameterList () const;
          void parameterList (string key, Parameter* value);

          //## Association: XSModel::Model::<unnamed>%3AA69292021E
          //## Role: ModelContainer::modelLookupTable%3AA692930067
          //## Qualifier: modelName%3AA692AB00F7; string
          const std::map<string,std::size_t>& modelLookupTable () const;
          const std::size_t modelLookupTable (string modelName) const;
          void modelLookupTable (string modelName, std::size_t value);

          //## Association: XSModel::Model::Component::<unnamed>%3F7DA30402FB
          //## Role: ModelContainer::mixingComponents%3F7DA30603D1
          //## Qualifier: name%3F7DA4A20208; string
          const std::map<string, MixBase*>& mixingComponents () const;
          void mixingComponents (const std::map<string, MixBase*>& value);
          MixBase* mixingComponents (string name) const;
          void mixingComponents (string name, MixBase* value);

          //## Association: XSUser::Global::<unnamed>%3C8F971E0361
          //## Role: ModelContainer::activeModelNames%3C8F97200073
          //## Qualifier: modelName%3C8F975C0360; string
          const std::map<string,bool>& activeModelNames () const;
          const bool activeModelNames (string modelName) const;

      public:
        // Additional Public Declarations
          //## begin XSContainer::ModelContainer%368930276EF8.public preserve=yes
          //## end XSContainer::ModelContainer%368930276EF8.public

      protected:
        // Additional Protected Declarations
          //## begin XSContainer::ModelContainer%368930276EF8.protected preserve=yes
          //## end XSContainer::ModelContainer%368930276EF8.protected

      private:
        //## Constructors (generated)
          ModelContainer();

          ModelContainer(const ModelContainer &right);

        //## Assignment Operation (generated)
          ModelContainer & operator=(const ModelContainer &right);


        //## Other Operations (specified)
          //## Operation: reindexParameterList%3A9C162F039C
          //	Reindex parameters in list after erasure of a model
          //	or a component.
          //
          //	Strictly private: called by Parameters' erase operations.
          //
          //	Parameters should have access to index field of the
          //	parameters in the list through the mutable keyword.
          //
          //	Arguments are:
          //	first - the index number one greater than
          //	the highest parameterList member erased.
          //
          //	reduceBy - the number of parameterList members
          //	erased.
          void reindexParameterList (int first, int reduceBy);

          //## Operation: addParameterLookup%3A9C1641034F
          void addParameterLookup (int index, const string& key);

          //## Operation: incrementModelCounter%3AA52C8D0159
          size_t incrementModelCounter ();

          //## Operation: deregisterModelParameters%3AAEA66A026E
          //	Erase parameters from the global parameter list.
          //
          //	Calls reindex to move index values of parameters
          //	with higher index numbers.
          void deregisterModelParameters (const string& keyString, size_t group);

          //## Operation: reAttachResponses%3C8E6BB20121
          void reAttachResponses (const string& modelName);

          //## Operation: deactivateOthers%3ED7863F0053
          void deactivateOthers (size_t sourceNum);

          //## Operation: verifyDataForMixing%3F9EE236011B
          void verifyDataForMixing ();

          //## Operation: initializeMixingTransformation%3FA285A70069
          void initializeMixingTransformation (const string& modelName) const;

          //## Operation: determineModelObjectStatus%4469E56C03A4
          void determineModelObjectStatus (std::map<string,std::vector<Model*> >& doomed, std::map<string,std::vector<Model*> >& alive, std::map<string,std::vector<size_t> >& needed);

        //## Get and Set Operations for Class Attributes (generated)

          //## Attribute: uniqueNamedModel%3AA515640051
          const size_t uniqueNamedModel () const;

        // Data Members for Associations

          //## Association: XSModel::Model::<unnamed>%36893410E850
          //## begin XSContainer::ModelContainer::modelSet%368934115728.role preserve=no  public: Model {1 -> 1..nRHgN}
          ModelMap m_modelSet;
          //## end XSContainer::ModelContainer::modelSet%368934115728.role

        // Additional Private Declarations
          //## begin XSContainer::ModelContainer%368930276EF8.private preserve=yes
          //## end XSContainer::ModelContainer%368930276EF8.private

      private: //## implementation
        // Data Members for Class Attributes

          //## Attribute: instance%373B0D27BC70
          //## begin XSContainer::ModelContainer::instance%373B0D27BC70.attr preserve=no  implementation: static ModelContainer* {V} 0
          static ModelContainer* s_instance;
          //## end XSContainer::ModelContainer::instance%373B0D27BC70.attr

          //## Attribute: parameterLookupTable%38F71CA868E8
          //## begin XSContainer::ModelContainer::parameterLookupTable%38F71CA868E8.attr preserve=no  private: std::map<int,string> {U} 
          std::map<int,string> m_parameterLookupTable;
          //## end XSContainer::ModelContainer::parameterLookupTable%38F71CA868E8.attr

          //## begin XSContainer::ModelContainer::uniqueNamedModel%3AA515640051.attr preserve=no  private: size_t {U} 0
          size_t m_uniqueNamedModel;
          //## end XSContainer::ModelContainer::uniqueNamedModel%3AA515640051.attr

          //## Attribute: SHIFT%3AA690870361
          //## begin XSContainer::ModelContainer::SHIFT%3AA690870361.attr preserve=no  public: static const size_t {U} 16
          static const size_t s_SHIFT;
          //## end XSContainer::ModelContainer::SHIFT%3AA690870361.attr

          //## Attribute: parameterReverseLookup%3C223BC9022E
          //## begin XSContainer::ModelContainer::parameterReverseLookup%3C223BC9022E.attr preserve=no  private: std::map<string,int> {U} 
          std::map<string,int> m_parameterReverseLookup;
          //## end XSContainer::ModelContainer::parameterReverseLookup%3C223BC9022E.attr

          //## begin XSContainer::ModelContainer::modelSystematicError%3E9C41E50388.attr preserve=no  public: Real {U} 
          Real m_modelSystematicError;
          //## end XSContainer::ModelContainer::modelSystematicError%3E9C41E50388.attr

          //## begin XSContainer::ModelContainer::autonomousEnergy%44037A2C03A0.attr preserve=no  public: RealArray {U} 
          RealArray m_autonomousEnergy;
          //## end XSContainer::ModelContainer::autonomousEnergy%44037A2C03A0.attr

          //## Attribute: modelForSource%447DF02B0077
          //## begin XSContainer::ModelContainer::modelForSource%447DF02B0077.attr preserve=no  private: std::map<size_t,string> {U} 
          std::map<size_t,string> m_modelForSource;
          //## end XSContainer::ModelContainer::modelForSource%447DF02B0077.attr

          //## begin XSContainer::ModelContainer::extendedEnergy%44F70F470376.attr preserve=no  public: ExtendRange {U} 
          ExtendRange m_extendedEnergy;
          //## end XSContainer::ModelContainer::extendedEnergy%44F70F470376.attr

          //## begin XSContainer::ModelContainer::proportionalDelta%47064F7A01FB.attr preserve=no  public: Real {U} 
          Real m_proportionalDelta;
          //## end XSContainer::ModelContainer::proportionalDelta%47064F7A01FB.attr

        // Data Members for Associations

          //## Association: XSModel::GlobalContainer::Cosmology Parameters%3E8DF06B0306
          //## begin XSContainer::ModelContainer::cosmo%3E8DF06C019F.role preserve=no  public: XSContainer::Cosmology { -> 1VHgN}
          Cosmology m_cosmo;
          //## end XSContainer::ModelContainer::cosmo%3E8DF06C019F.role

          //## Association: XSModel::GlobalContainer::<unnamed>%4810808503E5
          //## begin XSContainer::ModelContainer::userMdefs%48108086039D.role preserve=no  public: XSContainer::MdefContainer { -> 1RFHgN}
          MdefContainer* m_userMdefs;
          //## end XSContainer::ModelContainer::userMdefs%48108086039D.role

          //## Association: XSModel::Model::<unnamed>%3A9C16A801F0
          //## begin XSContainer::ModelContainer::parameterList%3A9C16A801F2.role preserve=no  public: Parameter { -> 1..nRFHgN}
          std::map<string,Parameter*> m_parameterList;
          //## end XSContainer::ModelContainer::parameterList%3A9C16A801F2.role

          //## Association: XSModel::Model::<unnamed>%3AA69292021E
          //## begin XSContainer::ModelContainer::modelLookupTable%3AA692930067.role preserve=no  public: std::size_t { -> 1..nVHgN}
          std::map<string,std::size_t> m_modelLookupTable;
          //## end XSContainer::ModelContainer::modelLookupTable%3AA692930067.role

          //## Association: XSModel::Model::Component::<unnamed>%3F7DA30402FB
          //## begin XSContainer::ModelContainer::mixingComponents%3F7DA30603D1.role preserve=no  public: MixBase { -> 1..nRFHgN}
          std::map<string, MixBase*> m_mixingComponents;
          //## end XSContainer::ModelContainer::mixingComponents%3F7DA30603D1.role

          //## Association: XSUser::Global::<unnamed>%3C8F971E0361
          //## begin XSContainer::ModelContainer::activeModelNames%3C8F97200073.role preserve=no  public: bool { -> 1..nVHgN}
          std::map<string,bool> m_activeModelNames;
          //## end XSContainer::ModelContainer::activeModelNames%3C8F97200073.role

        // Additional Implementation Declarations
          //## begin XSContainer::ModelContainer%368930276EF8.implementation preserve=yes
          //## end XSContainer::ModelContainer%368930276EF8.implementation

    };

    //## begin XSContainer::ModelContainer%368930276EF8.postscript preserve=yes
    //## end XSContainer::ModelContainer%368930276EF8.postscript

    // Class XSContainer::ModelContainer::NoSuchParameter 

    // Class XSContainer::ModelContainer 


    //## Other Operations (inline)
    inline size_t ModelContainer::SHIFT ()
    {
      //## begin XSContainer::ModelContainer::SHIFT%41598DE001CA.body preserve=yes
      return s_SHIFT;
      //## end XSContainer::ModelContainer::SHIFT%41598DE001CA.body
    }

    inline bool ModelContainer::isExtended () const
    {
      //## begin XSContainer::ModelContainer::isExtended%44F710870023.body preserve=yes
      return (m_extendedEnergy.first.nBins || m_extendedEnergy.second.nBins);
      //## end XSContainer::ModelContainer::isExtended%44F710870023.body
    }

    //## Get and Set Operations for Class Attributes (inline)

    inline const size_t ModelContainer::uniqueNamedModel () const
    {
      //## begin XSContainer::ModelContainer::uniqueNamedModel%3AA515640051.get preserve=no
      return m_uniqueNamedModel;
      //## end XSContainer::ModelContainer::uniqueNamedModel%3AA515640051.get
    }

    inline Real ModelContainer::modelSystematicError () const
    {
      //## begin XSContainer::ModelContainer::modelSystematicError%3E9C41E50388.get preserve=no
      return m_modelSystematicError;
      //## end XSContainer::ModelContainer::modelSystematicError%3E9C41E50388.get
    }

    inline void ModelContainer::modelSystematicError (Real value)
    {
      //## begin XSContainer::ModelContainer::modelSystematicError%3E9C41E50388.set preserve=no
      m_modelSystematicError = value;
      //## end XSContainer::ModelContainer::modelSystematicError%3E9C41E50388.set
    }

    inline const RealArray& ModelContainer::autonomousEnergy () const
    {
      //## begin XSContainer::ModelContainer::autonomousEnergy%44037A2C03A0.get preserve=no
      return m_autonomousEnergy;
      //## end XSContainer::ModelContainer::autonomousEnergy%44037A2C03A0.get
    }

    inline const ExtendRange& ModelContainer::extendedEnergy () const
    {
      //## begin XSContainer::ModelContainer::extendedEnergy%44F70F470376.get preserve=no
      return m_extendedEnergy;
      //## end XSContainer::ModelContainer::extendedEnergy%44F70F470376.get
    }

    inline Real ModelContainer::proportionalDelta () const
    {
      //## begin XSContainer::ModelContainer::proportionalDelta%47064F7A01FB.get preserve=no
      return m_proportionalDelta;
      //## end XSContainer::ModelContainer::proportionalDelta%47064F7A01FB.get
    }

    inline void ModelContainer::proportionalDelta (Real value)
    {
      //## begin XSContainer::ModelContainer::proportionalDelta%47064F7A01FB.set preserve=no
      m_proportionalDelta = value;
      //## end XSContainer::ModelContainer::proportionalDelta%47064F7A01FB.set
    }

    //## Get and Set Operations for Associations (inline)

    inline Cosmology& ModelContainer::cosmo ()
    {
      //## begin XSContainer::ModelContainer::cosmo%3E8DF06C019F.get preserve=no
      return m_cosmo;
      //## end XSContainer::ModelContainer::cosmo%3E8DF06C019F.get
    }

    inline void ModelContainer::cosmo (const Cosmology& value)
    {
      //## begin XSContainer::ModelContainer::cosmo%3E8DF06C019F.set preserve=no
      m_cosmo = value;
      //## end XSContainer::ModelContainer::cosmo%3E8DF06C019F.set
    }

    inline MdefContainer* ModelContainer::userMdefs ()
    {
      //## begin XSContainer::ModelContainer::userMdefs%48108086039D.get preserve=no
      return m_userMdefs;
      //## end XSContainer::ModelContainer::userMdefs%48108086039D.get
    }

    inline const ModelMap& ModelContainer::modelSet () const
    {
      //## begin XSContainer::ModelContainer::modelSet%368934115728.get preserve=no
      return m_modelSet;
      //## end XSContainer::ModelContainer::modelSet%368934115728.get
    }

    inline const std::map<string,Parameter*>& ModelContainer::parameterList () const
    {
      //## begin XSContainer::ModelContainer::parameterList%3A9C16A801F2.get preserve=no
      return m_parameterList;
      //## end XSContainer::ModelContainer::parameterList%3A9C16A801F2.get
    }

    inline const std::map<string,std::size_t>& ModelContainer::modelLookupTable () const
    {
      //## begin XSContainer::ModelContainer::modelLookupTable%3AA692930067.get preserve=no
      return m_modelLookupTable;
      //## end XSContainer::ModelContainer::modelLookupTable%3AA692930067.get
    }

    inline const std::size_t ModelContainer::modelLookupTable (string modelName) const
    {
      //## begin XSContainer::ModelContainer::modelLookupTable%3AA692930067.qualget preserve=yes
      std::map<string,size_t>::const_iterator f = m_modelLookupTable.find(modelName);
      return (f != m_modelLookupTable.end() ? f->second : 0);
      //## end XSContainer::ModelContainer::modelLookupTable%3AA692930067.qualget
    }

    inline void ModelContainer::modelLookupTable (string modelName, std::size_t value)
    {
      //## begin XSContainer::ModelContainer::modelLookupTable%3AA692930067.qualset preserve=no
      m_modelLookupTable[modelName] = value;
      //## end XSContainer::ModelContainer::modelLookupTable%3AA692930067.qualset
    }

    inline const std::map<string, MixBase*>& ModelContainer::mixingComponents () const
    {
      //## begin XSContainer::ModelContainer::mixingComponents%3F7DA30603D1.get preserve=no
      return m_mixingComponents;
      //## end XSContainer::ModelContainer::mixingComponents%3F7DA30603D1.get
    }

    inline void ModelContainer::mixingComponents (const std::map<string, MixBase*>& value)
    {
      //## begin XSContainer::ModelContainer::mixingComponents%3F7DA30603D1.set preserve=no
      m_mixingComponents = value;
      //## end XSContainer::ModelContainer::mixingComponents%3F7DA30603D1.set
    }

    inline MixBase* ModelContainer::mixingComponents (string name) const
    {
      //## begin XSContainer::ModelContainer::mixingComponents%3F7DA30603D1.qualget preserve=yes
      std::map<string,MixBase*>::const_iterator f = m_mixingComponents.find(name);
      return  ( f != m_mixingComponents.end() ? f->second : 0);
      //## end XSContainer::ModelContainer::mixingComponents%3F7DA30603D1.qualget
    }

    inline void ModelContainer::mixingComponents (string name, MixBase* value)
    {
      //## begin XSContainer::ModelContainer::mixingComponents%3F7DA30603D1.qualset preserve=no
      m_mixingComponents[name] = value;
      //## end XSContainer::ModelContainer::mixingComponents%3F7DA30603D1.qualset
    }

    inline const std::map<string,bool>& ModelContainer::activeModelNames () const
    {
      //## begin XSContainer::ModelContainer::activeModelNames%3C8F97200073.get preserve=no
      return m_activeModelNames;
      //## end XSContainer::ModelContainer::activeModelNames%3C8F97200073.get
    }

    inline const bool ModelContainer::activeModelNames (string modelName) const
    {
      //## begin XSContainer::ModelContainer::activeModelNames%3C8F97200073.qualget preserve=yes
      std::map<string,bool>::const_iterator f = m_activeModelNames.find(modelName);
      return (f != m_activeModelNames.end() ? f->second : false);
      //## end XSContainer::ModelContainer::activeModelNames%3C8F97200073.qualget
    }

} // namespace XSContainer

//## begin module%38188C7CA420.epilog preserve=yes
//## end module%38188C7CA420.epilog


#endif
